#include <VirtualWire.h>
#include "DHT.h"
#include "Adafruit_MCP9808.h"

#define DHTTYPE DHT22

const int dataPin = 9;
const int presPin = 15;
const int humPin = 5;

Adafruit_MCP9808 tempsensor = Adafruit_MCP9808();
DHT dht(humPin, DHTTYPE);

void setup(){
  
  Serial.begin(9600);
  vw_setup(2000);
  vw_set_tx_pin(dataPin);//Configura el pin de emisión RF
  pinMode(presPin, INPUT);//Configura el pin como entrada
  
  if (!tempsensor.begin(0x18)) {//Gestión de error en el sensor
    Serial.println("Dispositivo lector de temperatura MCP9808 no encontrado.");
    while (1);
  }
  tempsensor.setResolution(1);//Ajustar resolución del MCP9808
  tempsensor.wake();//Despertar el sensor MCP9808
  dht.begin();//Despertar el sensor DHT22
}

void loop(){
  
  String strtemp, strpres, strhum, strtemp2;
  char buf[VW_MAX_MESSAGE_LEN];
  int pres;
  float temp, hum, temp2;
  
  temp = tempsensor.readTempC();//Lectura de la temperatura de la habitacion
  //Serial.println(temp);
  strtemp = "t" + String(temp); // Convertir a string
  //Serial.println(strtemp);
  strtemp.toCharArray(buf, sizeof(buf)); // Convertir a char array
  vw_send((uint8_t *)buf, strlen(buf)); // Enviar array
  Serial.println("Enviando...");
  Serial.println(strtemp);
  vw_wait_tx(); // Esperar envio
  Serial.println("Listo!");
  
  int pres_ = analogRead(presPin); //Lectura valor entrada sensor de presion (0 - 1023)
  if (pres_ > 100){
    pres = 1;
  }
  else{
    pres = 0;
  }
  //Serial.println(pres);
  strpres = "p" + String(pres);  
  strpres.toCharArray(buf, sizeof(buf));
  vw_send((uint8_t *)buf, strlen(buf));
  Serial.println("Enviando...");
  Serial.println(strpres);
  vw_wait_tx();
  Serial.println("Listo!");

  hum = dht.readHumidity();
  //Serial.println(hum);
  strhum = "h" + String(hum);
  strhum.toCharArray(buf, sizeof(buf));
  vw_send((uint8_t *)buf, strlen(buf));
  Serial.println("Enviando...");
  Serial.println(strhum);
  vw_wait_tx();
  Serial.println("Listo!");
  
  temp2 = dht.readTemperature();
  //Serial.println(temp2);
  strtemp2 = "g" + String(temp2);
  strtemp2.toCharArray(buf, sizeof(buf));
  vw_send((uint8_t *)buf, strlen(buf));
  Serial.println("Enviando...");
  Serial.println(strtemp2);
  vw_wait_tx();
  Serial.println("Listo!");
  
  delay(500);
}
